/** \addtogroup tueEgoCoordComp
 *  @{
 * \file        tue_prv_egoCoordCompensation_int.h
 *
 * \brief internal header of the ego motion compensation AAU
 * 
* 
 *
 *          (C) Copyright Tuerme Inc. All rights reserved.
 *
 */

#ifndef TUE_PRV_EGOCOORDCOMPENSATION_INT_H
#define TUE_PRV_EGOCOORDCOMPENSATION_INT_H

#ifdef __cplusplus
extern "C" {
#endif

/*==================[inclusions]============================================*/
#include "tue_prv_common_types.h"
#include "tue_prv_common_matrix.h"

/*==================[macros]================================================*/

#define TUE_PRV_EGO_COORD_COMPENSATION_MIN_STATES_COMPENSATE_VEL (4u)
#define TUE_PRV_EGO_COORD_COMPENSATION_MIN_STATES_COMPENSATE_ACCX (5u)
#define TUE_PRV_EGO_COORD_COMPENSATION_MIN_STATES_COMPENSATE_ACCY (6u)
/*==================[type definitions]======================================*/
/*==================[forward declarations]==================================*/
/*==================[symbolic constants]====================================*/
/*==================[return codes]==========================================*/
/*==================[functions]=============================================*/

/************** Internal header******************/
/** @name Internal functions */

#define ObjFusn_START_SEC_CODE

LOCAL void EgoCoordCompensation_CoordRotation(CONSTP2VAR(float32, AUTOMATIC, ObjFusn_VAR_NOINIT) pf32X,
                                              CONSTP2VAR(float32, AUTOMATIC, ObjFusn_VAR_NOINIT) pf32Y,
                                              const float32 f32Sin, const float32 f32Cos);

LOCAL void EgoCoordCompensation_CoordTranslation(CONSTP2VAR(float32, AUTOMATIC, ObjFusn_VAR_NOINIT) pf32X,
                                                 CONSTP2VAR(float32, AUTOMATIC, ObjFusn_VAR_NOINIT) pf32Y,
                                                 const float32 f32DX, const float32 f32DY);
#define ObjFusn_STOP_SEC_CODE

/*==================[external function declarations]========================*/
/*==================[external constants]====================================*/
/*==================[external data]=========================================*/

#ifdef __cplusplus
}
#endif

#endif // TUE_PRV_EGOCOORDCOMPENSATION_INT_H
/*==================[end of file]===========================================*/

/** @} */ 
/** @} */
